// Copyright 2017, Vertex.AI.

#pragma once

#include <boost/uuid/uuid.hpp>

#include <string>

namespace vertexai {

// The Vertex.AI code UUID namespace -- UUIDs in this space are defined by strings in the Vertex.AI main source code
// repository.
extern const boost::uuids::uuid vertexai_uuid_namespace;

// Makes a name-based UUID, wired to the Vertex.AI UUID namespace.
boost::uuids::uuid GetVertexAIUUID(const char* name);

// Makes a random UUID, generated by a Mersenne Twister (mt19937) seeded by std::random_device.
boost::uuids::uuid GetRandomUUID();

// Turns a UUID into a byte string.
inline std::string ToByteString(const boost::uuids::uuid& u) { return std::string(u.begin(), u.end()); }

}  // namespace vertexai
